---
title: CanvasRenderingContext2D.addHitRegion()
slug: Web/API/CanvasRenderingContext2D/addHitRegion
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Experimental
  - Method
  - Reference
---
<div>{{APIRef}} {{obsolete_header}}</div>

<p>The {{domxref("CanvasRenderingContext2D")}} method <strong><code>addHitRegion()</code></strong> adds a hit region to the bitmap.</p>

<p>Canvas hit regions make hit detection easy. They let you route events to DOM elements, and make it possible for users to explore the canvas without seeing it.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <em>ctx</em>.addHitRegion(<em>options</em>);
</pre>

<h3 id="Options">Options</h3>

<p>The <code>options</code> argument is optional. When provided, it is an {{jsxref("Object")}} which can contain the following properties:</p>

<dl>
 <dt><code>path</code></dt>
 <dd>A {{domxref("Path2D")}} object describing the area of the hit region. If not provided, the current path is used.</dd>
 <dt><code>fillRule</code></dt>
 <dd>The algorithm by which to determine if a point is inside or outside the hit region.<br>
 Possible values:
 <ul>
  <li><strong><code>nonzero</code></strong>: The <a href="http://en.wikipedia.org/wiki/Nonzero-rule">non-zero winding rule</a>. Default rule.</li>
  <li><code><strong>evenodd</strong></code>: The <a href="http://en.wikipedia.org/wiki/Even%E2%80%93odd_rule">even-odd winding rule</a>.</li>
 </ul>
 </dd>
 <dt><code>id</code></dt>
 <dd>The ID for this hit region to reference it for later use in events, for example.</dd>
 <dt><code>parentID</code></dt>
 <dd>The ID of the parent region for cursor fallback and navigation by accessibility tools.</dd>
 <dt><code>cursor</code></dt>
 <dd>The {{cssxref("cursor")}} to use when the mouse is over this region (defaults to <code>inherit</code>). Inherits the cursor of the parent hit region, if any, or the canvas element's cursor.</dd>
 <dt><code>control</code></dt>
 <dd>An element (descendant of the canvas) to which events are to be routed. Defaults to <code>null</code>.</dd>
 <dt><code>label</code></dt>
 <dd>A text label for accessibility tools to use as a description of the region, if there is no control. Defaults to <code>null</code>.</dd>
 <dt><code>role</code></dt>
 <dd>An <a href="/en-US/docs/Web/Accessibility/ARIA">ARIA role</a> for accessibility tools to determine how to represent this region, if there is no control. Defaults to <code>null</code>.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Using_the_addHitRegion_method">Using the <code>addHitRegion</code> method</h3>

<p>This example demonstrates the <code>addHitRegion()</code> method.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js;">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

canvas.addEventListener('mousemove', function(event) {
  if(event.region) {
    alert('ouch, my eye :(');
  }
});

ctx.beginPath();
ctx.arc(100, 100, 75, 0, 2 * Math.PI);
ctx.lineWidth = 5;
ctx.stroke();

// Eyes
ctx.beginPath();
ctx.arc(70, 80, 10, 0, 2 * Math.PI);
ctx.arc(130, 80, 10, 0, 2 * Math.PI);
ctx.fill();
ctx.addHitRegion({id: "eyes"});

// Mouth
ctx.beginPath();
ctx.arc(100, 110, 50, 0, Math.PI);
ctx.stroke();
</pre>

<p>Edit the code below to see your changes update live in the canvas. (If you don't see the full smiley, check the browser compatibility table to see if your current browser supports hit regions already; you might need to activate a preference.)</p>

<div class="hidden">
<h6 id="Playable_code">Playable code</h6>

<pre class="brush: html">&lt;canvas id="canvas" width="400" height="200" class="playable-canvas"&gt;&lt;/canvas&gt;
&lt;div class="playable-buttons"&gt;
  &lt;input id="edit" type="button" value="Edit" /&gt;
  &lt;input id="reset" type="button" value="Reset" /&gt;
&lt;/div&gt;
&lt;textarea id="code" class="playable-code" style="height:250px"&gt;
ctx.beginPath();
ctx.arc(100, 100, 75, 0, 2 * Math.PI, false);
ctx.lineWidth = 5;
ctx.stroke();

// eyes
ctx.beginPath();
ctx.arc(70, 80, 10, 0, 2 * Math.PI, false);
ctx.arc(130, 80, 10, 0, 2 * Math.PI, false);
ctx.fill();
ctx.addHitRegion({id: "eyes"});

// mouth
ctx.beginPath();
ctx.arc(100, 110, 50, 0, Math.PI, false);
ctx.stroke();&lt;/textarea&gt;
</pre>

<pre class="brush: js">var canvas = document.getElementById("canvas");
var ctx = canvas.getContext("2d");
var textarea = document.getElementById("code");
var reset = document.getElementById("reset");
var edit = document.getElementById("edit");
var code = textarea.value;

function drawCanvas() {
  ctx.clearRect(0, 0, canvas.width, canvas.height);
  eval(textarea.value);
}

reset.addEventListener("click", function() {
  textarea.value = code;
  drawCanvas();
});

edit.addEventListener("click", function() {
  textarea.focus();
});

canvas.addEventListener("mousemove", function(event){
  if(event.region) {
    alert("ouch, my eye :(");
  }
});

textarea.addEventListener("input", drawCanvas);
window.addEventListener("load", drawCanvas);
</pre>
</div>

<p>{{ EmbedLiveSample('Playable_code', 700, 520) }}</p>

<h2 id="Specifications">Specifications</h2>

<p>Canvas hit regions have been removed from the WHATWG Living Standard, although discussions about future standardization are ongoing. See <a href="https://github.com/whatwg/html/issues/3407">https://github.com/whatwg/html/issues/3407</a> for more information.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.addHitRegion")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("CanvasRenderingContext2D.removeHitRegion()")}} {{experimental_inline}}</li>
 <li>{{domxref("CanvasRenderingContext2D.clearHitRegions()")}} {{experimental_inline}}</li>
</ul>
